//*************************************************
// CORSO PROGRAMMAZIONE PICMICRO
// appendice 1
// www.settorezero.com
//
// modulo: settings.h
// autore: Bernardo Giovanni
// data: 02/02/10
// descrizione: configurazione del picmicro
// per test con encoder in quadratura
//
//*************************************************

#define LCDBL  RC1 // retroilluminazione LCD
#define BUZZER RC0 // cicalino
#define ENCODER_PULSE RB0 // segnale di interrupt dall'encoder
#define ENCODER_DIR RB1 // secondo segnale, senza interrupt, dall'encoder
#define MINVAR 0 // valore minimo che pu assumere la variabile
#define MAXVAR 100 // valore massimo che pu assumere la variabile
#define INCR 1 // modalit incremento variabile
#define DECR 2 // modalit decremento variabile

signed char variabile=50; // variabile che modifichiamo con l'encoder ( da notare che  SIGNED)
unsigned char mode=0; // modalit (incremento o decremento)
bit suona; // flag per attivare il cicalino
unsigned char ABcounter=0; // contatore per antibounce gestito da timer0

void settings(void)
        {
        TRISA=0b00000000;
        TRISB=0b00000011;
        TRISC=0b00000000;
        TRISD=0b00000000;
        TRISE=0b00000000;
        
		// Impostazione Interrupt
		INTCON=0b10110000;
		// bit 0 -> RBIF - Flag interrupt su porte B
		// bit 1 -> INTF - Flag interrupt su RB0/INT
		// bit 2 -> T0IF - Flag interrupt su Timer0
		// bit 3 -> RBIE, Interrupt su porte B disattivato
		// bit 4 -> INTE, Interrupt su porta RB0/INT attivo
		// bit 5 -> TMR0IE, Interrupt su Timer0 attivo
		// bit 6 -> PEIE, Interrupt di periferica disattivato
		// bit 7 -> GIE, Gestione Interrupt attiva
		
		OPTION=0b00000100; // prescaler 1:32 => interrupt ogni millisecondo con quarzo da 20MHz
		// bit 0 -> PS0    Prescaler Rate Select bit 0
		// bit 1 -> PS1    Prescaler Rate Select bit 1
		// bit 2 -> PS2    Prescaler Rate Select bit 2
		// bit 3 -> PSA    Prescaler assegnato a Timer0 (1=Watchdog Timer)
		// bit 4 -> T0SE   Timer0 Signal Edge: 0=low->high 1=high->low
		// bit 5 -> T0CS   Timer0 Clock Select: internal clock (1=T0CKI transition)
		// bit 6 -> INTEDG INTerrupt Edge (1=raise 0=fall)
		// bit 7 -> RBPU   PortB PullUp (0=off 1=on)
		
		TMR0=100; // precarico timer0
        }